/** 
 * FormValidation (https://formvalidation.io)
 * The best validation library for JavaScript
 * (c) 2013 - 2023 Nguyen Huu Phuoc <me@phuoc.ng>
 *
 * @license https://formvalidation.io/license
 * @package @form-validation/plugin-framework
 * @version 2.1.0
 */

define(["exports","@form-validation/core","@form-validation/plugin-message"],(function(e,t,n){"use strict";var o=function(e,t){return o=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n])},o(e,t)};var s=t.utils.classSet,i=t.utils.closest,a=function(e){function t(t){var n=e.call(this,t)||this;return n.results=new Map,n.containers=new Map,n.MESSAGE_PLUGIN="___frameworkMessage",n.opts=Object.assign({},{defaultMessageContainer:!0,eleInvalidClass:"",eleValidClass:"",rowClasses:"",rowValidatingClass:""},t),n.elementIgnoredHandler=n.onElementIgnored.bind(n),n.elementValidatingHandler=n.onElementValidating.bind(n),n.elementValidatedHandler=n.onElementValidated.bind(n),n.elementNotValidatedHandler=n.onElementNotValidated.bind(n),n.iconPlacedHandler=n.onIconPlaced.bind(n),n.fieldAddedHandler=n.onFieldAdded.bind(n),n.fieldRemovedHandler=n.onFieldRemoved.bind(n),n.messagePlacedHandler=n.onMessagePlaced.bind(n),n}return function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function n(){this.constructor=e}o(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)}(t,e),t.prototype.install=function(){var e,t=this;s(this.core.getFormElement(),((e={})[this.opts.formClass]=!0,e["fv-plugins-framework"]=!0,e)),this.core.on("core.element.ignored",this.elementIgnoredHandler).on("core.element.validating",this.elementValidatingHandler).on("core.element.validated",this.elementValidatedHandler).on("core.element.notvalidated",this.elementNotValidatedHandler).on("plugins.icon.placed",this.iconPlacedHandler).on("core.field.added",this.fieldAddedHandler).on("core.field.removed",this.fieldRemovedHandler),this.opts.defaultMessageContainer&&(this.core.registerPlugin(this.MESSAGE_PLUGIN,new n.Message({clazz:this.opts.messageClass,container:function(e,o){var s="string"==typeof t.opts.rowSelector?t.opts.rowSelector:t.opts.rowSelector(e,o),a=i(o,s);return n.Message.getClosestContainer(o,a,t.opts.rowPattern)}})),this.core.on("plugins.message.placed",this.messagePlacedHandler))},t.prototype.uninstall=function(){var e;this.results.clear(),this.containers.clear(),s(this.core.getFormElement(),((e={})[this.opts.formClass]=!1,e["fv-plugins-framework"]=!1,e)),this.core.off("core.element.ignored",this.elementIgnoredHandler).off("core.element.validating",this.elementValidatingHandler).off("core.element.validated",this.elementValidatedHandler).off("core.element.notvalidated",this.elementNotValidatedHandler).off("plugins.icon.placed",this.iconPlacedHandler).off("core.field.added",this.fieldAddedHandler).off("core.field.removed",this.fieldRemovedHandler),this.opts.defaultMessageContainer&&(this.core.deregisterPlugin(this.MESSAGE_PLUGIN),this.core.off("plugins.message.placed",this.messagePlacedHandler))},t.prototype.onIconPlaced=function(e){},t.prototype.onMessagePlaced=function(e){},t.prototype.onFieldAdded=function(e){var t=this,n=e.elements;n&&(n.forEach((function(e){var n,o=t.containers.get(e);o&&(s(o,((n={})[t.opts.rowInvalidClass]=!1,n[t.opts.rowValidatingClass]=!1,n[t.opts.rowValidClass]=!1,n["fv-plugins-icon-container"]=!1,n)),t.containers.delete(e))})),this.prepareFieldContainer(e.field,n))},t.prototype.onFieldRemoved=function(e){var t=this;e.elements.forEach((function(e){var n,o=t.containers.get(e);o&&s(o,((n={})[t.opts.rowInvalidClass]=!1,n[t.opts.rowValidatingClass]=!1,n[t.opts.rowValidClass]=!1,n))}))},t.prototype.prepareFieldContainer=function(e,t){var n=this;if(t.length){var o=t[0].getAttribute("type");"radio"===o||"checkbox"===o?this.prepareElementContainer(e,t[0]):t.forEach((function(t){return n.prepareElementContainer(e,t)}))}},t.prototype.prepareElementContainer=function(e,t){var n,o="string"==typeof this.opts.rowSelector?this.opts.rowSelector:this.opts.rowSelector(e,t),a=i(t,o);a!==t&&(s(a,((n={})[this.opts.rowClasses]=!0,n["fv-plugins-icon-container"]=!0,n)),this.containers.set(t,a))},t.prototype.onElementValidating=function(e){this.removeClasses(e.element,e.elements)},t.prototype.onElementNotValidated=function(e){this.removeClasses(e.element,e.elements)},t.prototype.onElementIgnored=function(e){this.removeClasses(e.element,e.elements)},t.prototype.removeClasses=function(e,t){var n,o=this,i=e.getAttribute("type"),a="radio"===i||"checkbox"===i?t[0]:e;t.forEach((function(e){var t;s(e,((t={})[o.opts.eleValidClass]=!1,t[o.opts.eleInvalidClass]=!1,t))}));var l=this.containers.get(a);l&&s(l,((n={})[this.opts.rowInvalidClass]=!1,n[this.opts.rowValidatingClass]=!1,n[this.opts.rowValidClass]=!1,n))},t.prototype.onElementValidated=function(e){var t,n,o=this,i=e.elements,a=e.element.getAttribute("type"),l="radio"===a||"checkbox"===a?i[0]:e.element;i.forEach((function(t){var n;s(t,((n={})[o.opts.eleValidClass]=e.valid,n[o.opts.eleInvalidClass]=!e.valid,n))}));var r=this.containers.get(l);if(r)if(e.valid){this.results.delete(l);var d=!0;this.containers.forEach((function(e,t){e===r&&!1===o.results.get(t)&&(d=!1)})),d&&s(r,((n={})[this.opts.rowInvalidClass]=!1,n[this.opts.rowValidatingClass]=!1,n[this.opts.rowValidClass]=!0,n))}else this.results.set(l,!1),s(r,((t={})[this.opts.rowInvalidClass]=!0,t[this.opts.rowValidatingClass]=!1,t[this.opts.rowValidClass]=!1,t))},t}(t.Plugin);e.Framework=a}));
